#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "functions.h"
#include "functions_sse.h"
#include "huffman.h"
#include "list.h"
#include "aux.h"

//includes para opencv
#include <cv.h>
#include "highgui.h"


//para los tiempos
#include <sys/time.h>

void compress_image(FILE * image_in, int thresh, int assembler)
{
	struct timeval start,end;
	IplImage* image=0;
	image = cvLoadImage(image_in, CV_LOAD_IMAGE_GRAYSCALE );
	
	    cvNamedWindow( "w", 1);
    
    FILE *tiempos = fopen("tiempos_comprimir_imagen", "wb+");
	
    // Creamos el archivo del header_out
   	char name_out_header[strlen(image_in) +7 + 1];	// +7 por .header + 1 por null 
	
	strncpy(name_out_header, image_in, sizeof(name_out_header));
	strcat(name_out_header, ".header");
	FILE* header_out = fopen(name_out_header, "wb+");

    // Armamos el archivo del video_out
   	char name_out_image[strlen(image_in) + 4 + 1];	// +4 por .oc2 + 1 por null 
	
	strncpy(name_out_image, image_in, sizeof(name_out_image));
	strcat(name_out_image, ".oc2");
	
	FILE* image_out = fopen(name_out_image, "wb+");
	//~ FILE* entropia_out = fopen("entropia_imagen", "wb+");
	
	int high, width;
	high = image->height;
	width = image->width;

	oc2_main_header_t oc2;

	oc2.offset_first_frame_header = sizeof(oc2_main_header_t);
	oc2.cant_frames = 0;
	oc2.fourcc = 0;
	oc2.fps = 0;
	oc2.width = width; 
	oc2.height = high;
		
	fseek(header_out, 0, SEEK_SET);
	fwrite(&oc2.offset_first_frame_header, sizeof(unsigned int), 1, header_out);
	fwrite(&oc2.cant_frames, sizeof(int), 1, header_out);
	fwrite(&oc2.fourcc, sizeof(int), 1, header_out);
	fwrite(&oc2.fps, sizeof(double), 1, header_out);
	fwrite(&oc2.width, sizeof(int), 1, header_out);
	fwrite(&oc2.height, sizeof(int), 1, header_out);
	
	
	int **i_matrix;
	int i;
	i_matrix = (int**) malloc (image->height * sizeof (int*));    
	for (i = 0; i < image->height; i++)
		i_matrix[i] = (int*) malloc (image->width * sizeof (int));

	
	gettimeofday(&start,NULL);
	double tiempo;	
	
	read_image_ipl (image, i_matrix);
	
	//~ entropia(i_matrix, entropia_out, width, high);

	// Aplicamos jpge a la matriz correspondiente al frame
	if (assembler == corre_con_asm) jpeg_asm(i_matrix, width, high, thresh);
	if (assembler == corre_con_c) jpeg(i_matrix, width, high, thresh);
	
	//~ entropia(i_matrix, entropia_out, width, high);
	// Comprimimos y creamos los archivos de salida .oc2 y .header
	compress_frame(i_matrix, width, high, header_out, image_out);
	gettimeofday(&end,NULL);
	tiempo = (1000000*(end.tv_sec-start.tv_sec)+(end.tv_usec-start.tv_usec))/1000000.0;
	fprintf(tiempos, "%.10lf \n", tiempo);
	
        //~ for (i = 0; i < high; i++)
			//~ if(i_matrix[i] != 0) free (i_matrix[i]);
		//~ free(i_matrix);
	fclose(tiempos);
	//~ fclose(entropia_out);
}

void jpeg_from_webcam (int thresh, int assembler)
{
	struct timeval start,end;
    CvCapture* capture=0;
    IplImage* frame=0;
    capture = cvCaptureFromCAM(CV_CAP_ANY); // read AVI video    
    //~ FILE* entropia_out = fopen("entropia_webcam", "wb+");
    //~ FILE* psnr_out = fopen("psnr_webcam", "wb+");
    FILE* tiempos = fopen("tiempos_webcam", "wb+");
    cvNamedWindow( "w", 1);
    cvNamedWindow( "w_out", 1);

    //~ for( ; ; )
    int cant_frames;
    for(cant_frames = 0 ; cant_frames < 50; cant_frames++)
    {
		cvWaitKey(30);
        frame = cvQueryFrame( capture );
        
        if(!frame)
        {
            break;
        }
        IplImage *im_gray = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
		cvCvtColor(frame,im_gray,CV_BGR2GRAY);

		int high, width;
		high = im_gray->height;
		width = im_gray->width;

		
		int **i_matrix;
		int i;
		i_matrix = (int**) malloc (im_gray->height * sizeof (int*));    
		for (i = 0; i < im_gray->height; i++)
			i_matrix[i] = (int*) malloc (im_gray->width * sizeof (int)); 
		
		gettimeofday(&start,NULL);
		double tiempo;
		
		read_image_ipl (im_gray, i_matrix);
		//~ entropia(i_matrix, entropia_out, width, high);
		
		
		//~ int **matriz_orig;
		//~ matriz_orig = (int**) malloc (im_gray->height * sizeof (int*));    
		//~ for (i = 0; i < im_gray->height; i++)
			//~ matriz_orig[i] = (int*) malloc (im_gray->width * sizeof (int)); 
//~ 
		//~ read_image_ipl (im_gray, matriz_orig);
		
		int res;

		if (assembler == corre_con_asm){
			jpeg_asm (i_matrix, width, high, thresh);
			//~ for (i = 0; i < high; i++)
			//~ {
				//~ for(j=0; j< width; ++j){
					//~ printf("%d ",i_matrix[i][j]);
				//~ } 
				//~ printf(";\n");
			//~ }
			//~ printf("\n");
			//~ entropia(i_matrix, entropia_out, width, high);
			jpeg_dec_asm(i_matrix, width, high);
		}
		
		if (assembler == corre_con_c){
			jpeg(i_matrix, width, high, thresh);
			//~ entropia(i_matrix, entropia_out, width, high);
			jpeg_dec(i_matrix, width, high);
		}
		gettimeofday(&end,NULL);
		tiempo = (1000000*(end.tv_sec-start.tv_sec)+(end.tv_usec-start.tv_usec))/1000000.0;
		fprintf(tiempos, "%.10lf \n", tiempo);
		
        //~ psnr(matriz_orig, i_matrix, psnr_out, width, high);
        IplImage *im_out = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
        write_image_ipl (im_out, i_matrix);
        cvShowImage("w_out", im_out);
        cvShowImage("w", im_gray);
        //~ break;
    }
    fclose(tiempos);
    //~ fclose(entropia_out);
    //~ fclose(psnr_out);
    //~ cvWaitKey(0); // key press to close window
    cvDestroyWindow("w");
    cvReleaseImage(&frame);
    

}

int compress_AVI (char* name_video_in, int thresh, int assembler)
{
	struct timeval start,end;
    CvCapture* capture=0;
    IplImage* frame=0;
    capture = cvCaptureFromAVI(name_video_in); // read AVI video    
    
    cvNamedWindow( "w", 1);
    //~ cvNamedWindow( "w_out", 1);
    
    // Creamos el archivo del header_out
   	char name_out_header[strlen(name_video_in) +7 + 1];	// +7 por .header + 1 por null 
	
	strncpy(name_out_header, name_video_in, sizeof(name_out_header));
	strcat(name_out_header, ".header");
	FILE* header_out = fopen(name_out_header, "wb+");

    // Armamos el archivo del video_out
   	char name_out_video[strlen(name_video_in) + 4 + 1];	// +4 por .oc2 + 1 por null 
	
	strncpy(name_out_video, name_video_in, sizeof(name_out_header));
	strcat(name_out_video, ".oc2");
	
	FILE* video_out = fopen(name_out_video, "wb+");
	
	//~ FILE* entropia_out = fopen("entropia_AVI", "wb+");
	FILE* tiempos = fopen("tiempos_AVI", "wb+");
	
	
	write_info_oc2_main (header_out, capture);
	printf("Video size: %i x %i\n", 	(int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH),(int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT));

	// Comenzamos a comprimir por frame
    for( ; ; )
    {
		fseek(video_out, 0, SEEK_CUR);
		fseek(header_out, 0, SEEK_CUR);

		cvWaitKey(30);
		//~ printf("ciclando\n");
        frame = cvQueryFrame( capture );
		
        if(!frame) break;
        
        IplImage *im_gray = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
		cvCvtColor(frame,im_gray,CV_BGR2GRAY);
		//~ printf("depth %i, y channel %i \n", im_gray->depth, im_gray->nChannels);

		int high, width;
		high = im_gray->height;
		width = im_gray->width;
		
	
		int **i_matrix;
		int i;
		i_matrix = (int**) malloc (high * sizeof (int*));    
		for (i = 0; i < high; i++)
		{
			i_matrix[i] = (int*) malloc (width * sizeof (int)); 
			if(i_matrix[i]== 0) 
			{
				printf("Malloc dio NULL");
			}
		}
		
		gettimeofday(&start,NULL);
		double tiempo;
		
		read_image_ipl (im_gray, i_matrix);
		//~ entropia(i_matrix, entropia_out, width, high);

		int res;

		// Aplicamos jpge a la matriz correspondiente al frame
		if (assembler == corre_con_c) jpeg(i_matrix, width, high, thresh);
		if (assembler == corre_con_asm) jpeg_asm(i_matrix, width, high, thresh);
		
		//~ entropia(i_matrix, entropia_out, width, high);
		
		// Comprimimos y creamos los archivos de salida .oc2 y .header
		//~ printf("Antes de escribir el frame comprimido estoy en %i posicion del archivo\n", ftell(video_out));
		compress_frame(i_matrix, width, high, header_out, video_out);
        //~ printf("Despues de escribir el frame comprimido posicion %i del archivo\n", ftell(video_out));
        gettimeofday(&end,NULL);
		tiempo = (1000000*(end.tv_sec-start.tv_sec)+(end.tv_usec-start.tv_usec))/1000000.0;
		fprintf(tiempos, "%.10lf \n", tiempo);
	
        //printf("altura: %i, ancho %i\n", high, width);
        for (i = 0; i < high; i++)
		{ 
			//printf("posicion: %i puntero: %p \n", i, i_matrix[i]);
			if(i_matrix[i] != 0) free (i_matrix[i]);
			//printf("termine el free %i", i);
		}
		free(i_matrix); 
        //~ break;
        cvShowImage("w", im_gray);
    }
    //~ cvWaitKey(0); // key press to close window
    //~ cvDestroyWindow("w");
    //~ cvReleaseImage(&frame);
    fclose(tiempos);
    //~ fclose(entropia_out);
    fclose(header_out);
    fclose(video_out);
	return 0;
}

void compress_frame (int **i_matrix, int w, int h, FILE* header_out, FILE * video_out)
{
	int fila;
	int col;

	nodo_lista_ab * lista_ab;
	// Generar tabla de apariciones
	lista_ab = generar_tabla_apariciones(i_matrix, w, h);
	//~ mostrar_lista_ab(lista_ab);

	// Generar codigo
	nodo_lista_c * lista_c;
	lista_c = generar_lista_codigos(lista_ab);
	//~ imprimir_archivo_codigos(lista_c);
	

	// Generar arbol de huffman
	nodo_arbol_t * arbol;
	arbol = generar_arbol_huffman(lista_ab);
	if (arbol == NULL)
	{
		printf("	ERROR\n"); //hubo un problema en generar arbol
	}

	int error /*= eliminar_lista_ab (lista_ab)*/;
	//~ if (error) printf ("	ERROR");
		
	int * long_codificado;
	long_codificado = malloc(sizeof(int));
	*long_codificado = 0;
	generar_codigos(lista_c, long_codificado);
	//~ printf("long_codificado: %i\n", *long_codificado);
	//~ mostrar_codigos(lista_c);
	//Eliminar arbol huffman
	int cant_nodos_elim = eliminar_arbol (arbol);
	
	compress_buffer_file(i_matrix, w, h, lista_c, *long_codificado, video_out);
	int p;
	int m;
	m = (*long_codificado + (32-*long_codificado % 32))/32;
	//~ printf("longitud de codificacion mod 32 %i \n", *long_codificado % 32);
	//~ printf("longitud de codificacion redondeado a b %i \n", *long_codificado + (32-*long_codificado % 32));
	//~ printf("longitud de codificacion  %i ints\n", m);
	//~ printf("longitud de codificacion %i b\n", *long_codificado);
	
	write_header_video(*long_codificado, lista_c, header_out);

	//~ printf("Eliminar lista de codigos\n");
	error = eliminar_lista (lista_c);
	if (error) printf ("	ERROR");

	//~ printf("Fin Comprimir...\n");
}

void compress_buffer_file (int ** i_matrix, int width, int high, nodo_lista_c * lista, int long_codificado, FILE* buffer)
{
	int i, j, simb, cant_bits, long_cod_actual;
	unsigned int to_write, cod_aux, cod_actual;
	
	nodo_lista_c * nodo_anterior;
	
	to_write = 0;
	cod_aux = 0;
	cod_actual = 0;
	cant_bits = 0;
	
	int cant_int_file = 0;
	//~ fseek(buffer, 0, SEEK_CUR);
	
	for (i = 0; i < high; ++i){
		for(j = 0; j < width; ++j){
			
			simb = i_matrix[i][j];
			//~ printf("simbolo a comprimir %i \n", simb);
			long_cod_actual = buscar_simbolo(lista, simb, nodo_anterior)->long_cod;
			//~ printf("long cod actual = %i \n", long_cod_actual);
			cod_actual = buscar_simbolo(lista, simb, nodo_anterior)->codigo;
			//~ printf("cod actual = %i\n", cod_actual);
			cod_aux = cod_actual;
			cant_bits = cant_bits + long_cod_actual;
			if (cant_bits > 32) cod_aux = cod_aux >> abs(32-cant_bits);
			else cod_aux = cod_aux << 32-cant_bits;
			//~ printf("cod_aux = int %i hex %X", cod_aux, cod_aux);
			to_write = to_write | cod_aux;
			//~ printf("  to_write: %i, %X \n", to_write, to_write);
			//~ printf("  cant bits: %i \n", cant_bits);
			if (cant_bits > 32)
			{
				//~ printf("entre al primer if\n");
				fwrite(&to_write, sizeof(unsigned int), 1, buffer);
	cant_int_file++;
				to_write = 0;
				cod_aux = cod_actual;
				cod_aux = cod_aux << 32 - (cant_bits - 32);
				//~ printf("ya shift cod_aux = int %i hex %X\n", cod_aux, cod_aux);
				to_write = cod_aux;
				cant_bits = (cant_bits - 32);
			}else{
			
				if (cant_bits == 32)
				{
					//~ printf("entre al 2do if\n");
					fwrite(&to_write, sizeof(unsigned int), 1, buffer);
	cant_int_file++;
					to_write = 0;
					cant_bits = 0;
				}
			}
		}
	}
	
	if (cant_bits > 0){
		fwrite(&to_write, sizeof(unsigned int), 1, buffer);
	cant_int_file++;
	}
	//~ printf("Cantidad de ints impresos en el archivo por frame %i\n", cant_int_file);
}

void write_info_oc2_main (FILE * image_out, CvCapture * capture)
{
	printf ("Escribiendo header oc main2\n");

	oc2_main_header_t oc2;

	oc2.offset_first_frame_header = sizeof(oc2_main_header_t);
	oc2.cant_frames = (int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_COUNT);
	oc2.fourcc = (int)cvGetCaptureProperty(capture, CV_CAP_PROP_FOURCC);
	oc2.fps = cvGetCaptureProperty(capture, CV_CAP_PROP_FPS);
	oc2.width = (int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH); 
	oc2.height = (int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT);
		
	fseek(image_out, 0, SEEK_SET);
	fwrite(&oc2.offset_first_frame_header, sizeof(unsigned int), 1, image_out);
	fwrite(&oc2.cant_frames, sizeof(int), 1, image_out);
	fwrite(&oc2.fourcc, sizeof(int), 1, image_out);
	fwrite(&oc2.fps, sizeof(double), 1, image_out);
	fwrite(&oc2.width, sizeof(int), 1, image_out);
	fwrite(&oc2.height, sizeof(int), 1, image_out);
	
	//~ printf("offset %i %X\n", oc2.offset_first_frame_header, oc2.offset_first_frame_header);
	//~ printf("cant frames %i %X\n", oc2.cant_frames, oc2.cant_frames);
	//~ printf("fourcc %i %X\n", oc2.fourcc, oc2.fourcc);
	//~ printf("fps %f %X\n", oc2.fps, oc2.fps);
	//~ printf("width %i %X\n", oc2.width, oc2.width);
	//~ printf("height %i %X\n", oc2.height, oc2.height);
	
}
int compress_and_descompress_AVI (char* name_video_in, int thresh, int assembler)
{
    CvCapture* capture=0;
    IplImage* frame=0;
    capture = cvCaptureFromAVI(name_video_in); // read AVI video    
    
    cvNamedWindow( "w", 1);
    cvNamedWindow( "w_r", 1);
    // Creamos el archivo del header_out
   	char name_out_header[strlen(name_video_in) +7 + 1];	// +7 por .header + 1 por null 
	
	strncpy(name_out_header, name_video_in, sizeof(name_out_header));
	strcat(name_out_header, ".header");
	

    // Armamos el archivo del video_out
   	char name_out_video[strlen(name_video_in) + 4 + 1];	// +4 por .oc2 + 1 por null 
	
	strncpy(name_out_video, name_video_in, sizeof(name_out_video));
	strcat(name_out_video, ".oc2");
   	
   	char name_out_video_rec[strlen(name_video_in) + 8 + 1];	// +4 por oc2R.AVI + 1 por null 
	
	strncpy(name_out_video_rec, name_video_in, sizeof(name_out_video_rec));
	strcat(name_out_video_rec, "oc2R.AVI");	
	
	
	//~ FILE* entropia_out = fopen("entropia_AVI", "wb+");
	
	//~ FILE* psnr_out = fopen("psnr_AVI", "wb+");
	CvSize frame_size = cvSize((int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH),(int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT));
	CvVideoWriter* video_out_rec = cvCreateVideoWriter(name_out_video_rec, (int)cvGetCaptureProperty(capture, CV_CAP_PROP_FOURCC), cvGetCaptureProperty(capture, CV_CAP_PROP_FPS), frame_size, 0 );
	printf("Video size: %i x %i\n", 	(int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH),(int)cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT));

	// Comenzamos a comprimir por frame
    for( ; ; )
    {
		FILE* video_out = fopen(name_out_video, "wb+");
		FILE* header_out = fopen(name_out_header, "wb+");
		//~ write_info_oc2_main (header_out, capture);
		fseek(video_out, 0, SEEK_CUR);
		fseek(header_out, 0, SEEK_CUR);

		cvWaitKey(30);
		//~ printf("ciclando\n");
        frame = cvQueryFrame( capture );
		
        if(!frame) break;
        
        IplImage *im_gray = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
		cvCvtColor(frame,im_gray,CV_BGR2GRAY);
		//~ printf("depth %i, y channel %i \n", im_gray->depth, im_gray->nChannels);

		int high, width;
		high = im_gray->height;
		width = im_gray->width;
		
		int **i_matrix;
		int i;
		i_matrix = (int**) malloc (high * sizeof (int*));    
		for (i = 0; i < high; i++)
		{
			i_matrix[i] = (int*) malloc (width * sizeof (int)); 
			if(i_matrix[i]== 0) 
			{
				printf("Malloc dio NULL");
			}
		}

		read_image_ipl (im_gray, i_matrix);
		//~ entropia(i_matrix, entropia_out, width, high);
		
		//~ int **matriz_orig;
		//~ matriz_orig = (int**) malloc (im_gray->height * sizeof (int*));    
		//~ for (i = 0; i < im_gray->height; i++)
			//~ matriz_orig[i] = (int*) malloc (im_gray->width * sizeof (int)); 
//~ 
		//~ read_image_ipl (im_gray, matriz_orig);
		
		int res;

		// Aplicamos jpge a la matriz correspondiente al frame
		
		if (assembler == corre_con_asm){
			jpeg_asm (i_matrix, width, high, thresh);
			//~ entropia(i_matrix, entropia_out, width, high);
			//~ jpeg_dec_asm(i_matrix, width, high);
		}
		
		if (assembler == corre_con_c){
			jpeg(i_matrix, width, high, thresh);
			//~ entropia(i_matrix, entropia_out, width, high);
			//~ jpeg_dec(i_matrix, width, high);
		}
        //~ psnr(matriz_orig, i_matrix, psnr_out, width, high);
		
		
		// Comprimimos y creamos los archivos de salida .oc2 y .header
		//~ printf("Antes de escribir el frame comprimido estoy en %i posicion del archivo\n", ftell(video_out));
		compress_frame(i_matrix, width, high, header_out, video_out);
		fseek(video_out, 0, SEEK_SET);
		fseek(header_out, 0, SEEK_SET);
		descompress_frame(i_matrix, width, high, header_out, video_out, 0, 0);
        //~ printf("Despues de escribir el frame comprimido posicion %i del archivo\n", ftell(video_out));
        if (assembler == corre_con_asm) jpeg_dec_asm(i_matrix, width, high);
		if (assembler == corre_con_c) jpeg_dec(i_matrix, width, high);
		IplImage* frame_r = cvCreateImage(frame_size, IPL_DEPTH_8U, 1);
		write_image_ipl (frame_r, i_matrix);
		int write_OK = cvWriteFrame(video_out_rec, frame_r);
		remove(name_out_video);
		remove(name_out_header);
        //printf("altura: %i, ancho %i\n", high, width);
        for (i = 0; i < high; i++)
		{ 
			if(i_matrix[i] != 0) free (i_matrix[i]);
		}
		free(i_matrix); 
		//~ for (i = 0; i < high; i++)
		//~ { 
			//~ if(matriz_orig[i] != 0) free (matriz_orig[i]);
		//~ }
		//~ free(matriz_orig); 
        
        cvShowImage("w", im_gray);
        cvShowImage("w_r", frame_r);
    }
    //~ cvWaitKey(0); // key press to close window
    cvDestroyWindow("w");
    cvReleaseImage(&frame);
    //~ fclose(psnr_out);
    //~ fclose(entropia_out);
	return 0;
}
void compress_and_decompress_image(FILE * image_in, int thresh, int assembler)
{
	struct timeval start,end;
	IplImage* image=0;
	image = cvLoadImage(image_in, CV_LOAD_IMAGE_GRAYSCALE );
	
	cvNamedWindow( "w", 1);
    
	FILE* psnr_out = fopen("psnr_image", "wb+");
	
    // Creamos el archivo del header_out
   	char name_out_header[strlen(image_in) +7 + 1];	// +7 por .header + 1 por null 
	
	strncpy(name_out_header, image_in, sizeof(name_out_header));
	strcat(name_out_header, ".header");
	FILE* header_out = fopen(name_out_header, "wb+");

    // Armamos el archivo del video_out
   	char name_out_image[strlen(image_in) + 4 + 1];	// +4 por .oc2 + 1 por null 
	
	strncpy(name_out_image, image_in, sizeof(name_out_image));
	strcat(name_out_image, ".oc2");
	
	FILE* image_out = fopen(name_out_image, "wb+");
	FILE* entropia_out = fopen("entropia_imagen", "wb+");
	FILE* tiempos = fopen("tiempos_AVI", "wb+");
	int high, width;
	high = image->height;
	width = image->width;

	oc2_main_header_t oc2;

	oc2.offset_first_frame_header = sizeof(oc2_main_header_t);
	oc2.cant_frames = 0;
	oc2.fourcc = 0;
	oc2.fps = 0;
	oc2.width = width; 
	oc2.height = high;
		
	fseek(header_out, 0, SEEK_SET);
	fwrite(&oc2.offset_first_frame_header, sizeof(unsigned int), 1, header_out);
	fwrite(&oc2.cant_frames, sizeof(int), 1, header_out);
	fwrite(&oc2.fourcc, sizeof(int), 1, header_out);
	fwrite(&oc2.fps, sizeof(double), 1, header_out);
	fwrite(&oc2.width, sizeof(int), 1, header_out);
	fwrite(&oc2.height, sizeof(int), 1, header_out);
	
	gettimeofday(&start,NULL);
	double tiempo;
	
	int **i_matrix;
	int i;
	i_matrix = (int**) malloc (image->height * sizeof (int*));    
	for (i = 0; i < image->height; i++)
		i_matrix[i] = (int*) malloc (image->width * sizeof (int));

	read_image_ipl (image, i_matrix);
	
	entropia(i_matrix, entropia_out, width, high);
	int **matriz_orig;
	matriz_orig = (int**) malloc (image->height * sizeof (int*));    
	for (i = 0; i < image->height; i++)
		matriz_orig[i] = (int*) malloc (image->width * sizeof (int)); 

	read_image_ipl (image, matriz_orig);
		

	// Aplicamos jpge a la matriz correspondiente al frame
		
	if (assembler == corre_con_asm){
		jpeg_asm (i_matrix, width, high, thresh);
		entropia(i_matrix, entropia_out, width, high);
		jpeg_dec_asm(i_matrix, width, high);
	}
	
	if (assembler == corre_con_c){
		jpeg(i_matrix, width, high, thresh);
		entropia(i_matrix, entropia_out, width, high);
		jpeg_dec(i_matrix, width, high);
	}
	
	gettimeofday(&end,NULL);
	tiempo = (1000000*(end.tv_sec-start.tv_sec)+(end.tv_usec-start.tv_usec))/1000000.0;
	fprintf(tiempos, "%.10lf \n", tiempo);
		
	psnr(matriz_orig, i_matrix, psnr_out, width, high);
	
	entropia(i_matrix, entropia_out, width, high);
	// Comprimimos y creamos los archivos de salida .oc2 y .header
	//~ compress_frame(i_matrix, width, high, header_out, image_out);
	
	for (i = 0; i < high; i++)
		if(i_matrix[i] != 0) free (i_matrix[i]);
	free(i_matrix);
	for (i = 0; i < high; i++)
	{ 
		if(matriz_orig[i] != 0) free (matriz_orig[i]);
	}
	free(matriz_orig); 
    
    fclose(tiempos);
	fclose(entropia_out);
	fclose(psnr_out);
}
