#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "functions.h"
#include "huffman.h"
#include "list.h"

//includes para opencv
//#include <cv.h>
//#include "highgui.h"


double x[8] = {125, 3, -1, 12, 13, 15, -125, -122};
double xdct[8];
double xidct[8];
const double pi = 3.14159265359;
double temp[8][8], temp2[8][8];
#define PI 3.14159265358979

void coseno()
{
	int c, b;
	for(b=0;b<8;b++)
	{
		for(c=0;c<8;c++)
		{
			printf("c:	%i b:	%i, coseno:	%f		\n", c , b , cos((pi/8)*(c+0.5)*b));
			//~ printf("c:	%i b:	%i, coseno:	%i		\n", c , b , cos((pi/8)*(c+0.5)*b));
		}
		printf("\n");
	}
}

void read_image_ipl (IplImage *imagen_in, int **m)
{
	int i;
	int j;	
	i=0;
	for( i; i<imagen_in->height; i++ ) 
	{ 
		unsigned char* ptr = ( imagen_in->imageData + i * imagen_in->width ); 
		for( j=0 ; j<imagen_in->width; j++ ) { 
			m[i][j] = ptr[j]; 
		}
	}
}

void read_image(FILE * image_in, int **m, int width, int high, int begin, int size)
{
	int i;
	int j;
	fseek(image_in, begin, SEEK_SET);

	for(i=0; i<width; i++)
	{
		for(j=0; j<high; j++)
		{
			m[i][j] = fgetc(image_in);
		
			//~ printf("m[%i][%i]: %d \n", i,j, *aux);
		}	
	}	
}

void write_image_ipl (IplImage * imagen_out, int **m)
{
	int i;
	int j;	
	i=0;
	for( i; i<imagen_out->height; i++ ) 
	{ 
		unsigned char* ptr = ( imagen_out->imageData + i * imagen_out->width ); 
		for( j=0 ; j<imagen_out->width; j++ ) { 
			ptr[j] = m[i][j]; 
		}
	}

}

void write_image(FILE * image_out, int **m, int width, int high, int begin, int size)
{
	int i;
	int j;
	int aux;
	fseek(image_out, begin, SEEK_SET);
	for(i=0; i<width; i++)
	{
		for(j=0; j<high; j++)
		{
			aux = fputc(m[i][j],image_out);
			if (aux != m[i][j]){
				printf("Error de escritura\n");
			}
			//~ printf("m[%i][%i]: *aux: %d y aux: %d \n", i,j, *aux, aux);
		}	
	}
	
	
}

void jpeg(int ** i_matrix, int width, int high, int thresh)
{
	substract_128(i_matrix, width, high);
	
	divide_by_blocks_and_dct(i_matrix, width, high);
		
	divide_by_blocks_and_quant(i_matrix, width, high);
	
	//~ threshold (i_matrix, width, high, thresh);
}

void substract_128( int ** i_matrix, int width, int high)
{
	//printf("substract_128\n");
	int i, j;
	//~ printf("w: %i h: %i \n", width, high);
	for(i = 0; i < high ; i++)
	{
		for(j = 0; j < width ; j++)
		{
			i_matrix[i][j] = i_matrix[i][j] - 128;
		}
	}
	
}

void add_128( int ** i_matrix, int width, int high)
{
	//printf("add_128\n");
	int i, j;
	//~ printf("w: %i h: %i \n", width, high);
	for(i = 0; i < high ; i++)
	{
		for(j = 0; j < width ; j++)
		{
			i_matrix[i][j] = i_matrix[i][j] + 128;
		}
	}
	//~ test_range256(i_matrix, width, high);
	
}

void dct2(int **imagen, int i, int j)
{
	
	int a,b,c;
	for(a=0;a<8;++a){
		//~ printf("fila %i imagen_in: %i %i %i %i %i %i %i %i \n", a, imagen[i+a][j+0], imagen[i+a][j+1], imagen[i+a][j+2], imagen[i+a][j+3], imagen[i+a][j+4], imagen[i+a][j+5], imagen[i+a][j+6], imagen[i+a][j+7]);
		for(b=0;b<8;++b){
			temp[a][b]=0.0;
			for(c=0;c<8;++c){
				temp[a][b]+=imagen[i+a][j+c]*cos((pi/8)*(c+0.5)*b);
			}
			if(!b)temp[a][b]/=sqrt(8);
			if(b)temp[a][b]/=2;
		}
		//~ printf("temp: %i %i %i %i %i %i %i %i \n", (int)temp[a][0], (int)temp[a][1], (int)temp[a][2], (int)temp[a][3], (int)temp[a][4], (int)temp[a][5], (int)temp[a][6], (int)temp[a][7]);
	}
	
	
	for(b=0;b<8;++b){
		for(a=0;a<8;++a){
			temp2[a][b]=0.0;
			for(c=0;c<8;++c){
				temp2[a][b]+=temp[c][b]*cos((pi/8)*(c+0.5)*a);
			}
			if(!a)temp2[a][b]/=sqrt(8);
			if(a)temp2[a][b]/=2;
		}
	}
	for(a=0;a<8;++a)for(b=0;b<8;++b)imagen[i+a][j+b]=temp2[a][b];
	return;
}

void idct2(int** imagen, int i, int j)
{
	int a,b,c;
	for(b=0;b<8;++b){
		for(a=0;a<8;++a){
			temp[a][b] = 0.5*imagen[i][b+j]*sqrt(8);
			for(c=1;c<8;++c){
				temp[a][b] += imagen[i+c][b+j]*2*cos((pi*c/8)*(a+0.5));
			}
			temp[a][b]*=0.25;
		}
	}
	
	for(a=0;a<8;++a){
		for(b=0;b<8;++b){
			temp2[a][b] = 0.5*temp[a][0]*sqrt(8);
			for(c=1;c<8;++c){
				temp2[a][b] += temp[a][c]*2*cos((pi*c/8)*(b+0.5));
			}
			temp2[a][b]*=0.25;
		}
	}
	for(a=0;a<8;++a)for(b=0;b<8;++b)imagen[i+a][j+b]=temp2[a][b];
}

void divide_by_blocks_and_dct(int ** i_matrix, int width, int high)
{
	int row_m ;
	int col_m ;
	int row_b ;
	int col_b ;
	
	int cant_blocks_w = width / 8;
	int cant_blocks_h = high / 8;
	
	for(row_m = 0; row_m < cant_blocks_h; row_m++)
	{
		for(col_m = 0; col_m < cant_blocks_w; col_m++)
		{
			row_b = row_m * 8;
			col_b = col_m * 8;
			dct2(i_matrix, row_b, col_b );
		}
	}
	
}

void print_matrix(int ** i_matrix, int width, int high)
{
	printf("print_matrix\n");
	int r = 0;
	int c = 0;
	int cant = 0;
	printf("w: %i, h: %i \n", width, high);
	for(r = 0; r < high; r++)
	{
		printf("\n r: %i \n ", r);
		for(c = 0; c < width; c++) 
		{
			printf("%i	", (int) i_matrix[r][c]);
			cant++;
		}
		printf(" \n cant: %i \n ", cant);
		cant = 0;
	}
	printf("\n\n");	
}

void quantization(int ** i_matrix, int row_b, int col_b)
{

	int q_block[8][8] = {{16, 11, 10, 16, 24, 40, 51, 61},
                         {12, 12, 14, 19, 26, 58, 60, 55},
                         {14, 13, 16, 24, 40, 57, 69, 56},
                         {14, 17, 22, 29, 51, 87, 80, 62},
                         {18, 22, 37, 56, 68, 109, 103, 77},
                         {24, 35, 55, 64, 81, 104, 113, 92},
                         {49, 64, 78, 87, 103, 121, 120, 101},
                         {72, 92, 95, 98, 112, 100, 103, 99}};

	int row;
	row = row_b;
	int col;
	col = col_b;
	for (row = row_b; row < row_b+8; row++)
	{	
		for (col = col_b; col < col_b+8; col++)
		{
			i_matrix[row][col] = i_matrix[row][col]/q_block[row % 8][col % 8];
			//~ printf("%d ", i_matrix[row][col]);
		}	
		//~ puts("");
	}
}

void divide_by_blocks_and_quant(int ** i_matrix, int width, int high)
{
	int row_m ;
	int col_m ;
	int row_b ;
	int col_b ;
	
	
	int cant_blocks_w = width / 8;
	int cant_blocks_h = high / 8;
	
	
	for(row_m = 0; row_m < cant_blocks_h; row_m++)
	{
		for(col_m = 0; col_m < cant_blocks_w; col_m++)
		{
			row_b = row_m * 8;
			col_b = col_m * 8;
			quantization(i_matrix, row_b, col_b);
		}
	}
	
}

void threshold (int ** i_matrix, int width, int high, int threshold)
{
	int row = 0;
	int col = 0;
	
	for (row = 0; row < high; row++)
	{	
		for (col = 0; col < width; col++)
		{
			//~ printf("i_matrix[%i][%i]: %i, thres: %i", row, col, i_matrix[row][col], threshold);
			i_matrix[row][col] = (i_matrix[row][col] > threshold) ? i_matrix[row][col] : 0;
			//~ printf(" res i_matrix[%i][%i]: 		%i\n", row, col, i_matrix[row][col]);
		}	
	}
	
}

void jpeg_dec(int ** i_matrix, int width, int high)
{
	divide_by_blocks_and_m_quant(i_matrix, width, high);
	
	divide_by_blocks_and_idct(i_matrix, width, high);

	add_128(i_matrix, width, high);
	
}

void mult_quantization(int ** i_matrix, int row_b, int col_b)
{

	int q_block[8][8] = {{16, 11, 10, 16, 24, 40, 51, 61},
                         {12, 12, 14, 19, 26, 58, 60, 55},
                         {14, 13, 16, 24, 40, 57, 69, 56},
                         {14, 17, 22, 29, 51, 87, 80, 62},
                         {18, 22, 37, 56, 68, 109, 103, 77},
                         {24, 35, 55, 64, 81, 104, 113, 92},
                         {49, 64, 78, 87, 103, 121, 120, 101},
                         {72, 92, 95, 98, 112, 100, 103, 99}};

	int row;
	row = row_b;
	int col;
	col = col_b;
	for (row = row_b; row < row_b+8; row++)
	{	
		for (col = col_b; col < col_b+8; col++)
		{
			i_matrix[row][col] = i_matrix[row][col]*q_block[row % 8][col % 8];
			//~ printf("%d ", i_matrix[row][col]);
		}
		//~ puts("");	
	}
}

void divide_by_blocks_and_m_quant(int ** i_matrix, int width, int high)
{
	int row_m ;
	int col_m ;
	int row_b ;
	int col_b ;
	
	int cant_blocks_w = width / 8;
	int cant_blocks_h = high / 8;
	
	
	for(row_m = 0; row_m < cant_blocks_h; row_m++)
	{
		for(col_m = 0; col_m < cant_blocks_w; col_m++)
		{
			row_b = row_m * 8;
			col_b = col_m * 8;
			mult_quantization(i_matrix, row_b, col_b);
		}
	}
	
}

void divide_by_blocks_and_idct(int ** i_matrix, int width, int high)
{
	int row_m ;
	int col_m ;
	int row_b ;
	int col_b ;
	
	int cant_blocks_w = width / 8;
	int cant_blocks_h = high / 8;
		
	for(row_m = 0; row_m < cant_blocks_h; row_m++)
	{
		for(col_m = 0; col_m < cant_blocks_w; col_m++)
		{
			row_b = row_m * 8;
			col_b = col_m * 8;
			idct2(i_matrix, row_b, col_b );
		}
	}
	
}
/*
void reduce_image(int ** i_matrix, int WIDTH, int HIGH)
{
	printf("es necesario reducir la imagen? %i\n", (HIGH % 8) != 0 || (WIDTH % 8) != 0);
	//me fijo si realmente necesito achicar la imagen por alguna parte
	if((HIGH % 8) != 0 || (WIDTH % 8) != 0)
	{
		//necesito volver a generar  
		//calculo los nuevos valores de ancho y alto
		int high_nuevo;
		high_nuevo = HIGH - (HIGH % 8);
		int width_nuevo;
		width_nuevo = WIDTH - (WIDTH % 8);
		
		//vuelvo a generar la matriz copiandola parte que corresponde
		int **i_matrix_red;
		int i,j;
		i_matrix_red = (int**) malloc (high_nuevo * sizeof (int*));    
		for (i = 0; i < high_nuevo; i++)
		{
			i_matrix_red[i] = (int*) malloc (width_nuevo * sizeof (int)); 
        }
        // ya tengo la memoria para generar la nueva matriz
        
        //ahora copio el medio de la matriz
		for(i = 0; i < high_nuevo; i++)
		{
			for(j = 0; j < width_nuevo; j++)
			{
				//me corro la mitad de las columnas y filas para tomar la parte de la imagen lo mas central posible
				i_matrix_red[i][j] = i_matrix[i+((HIGH % 8)/ 2)][j+ ((WIDTH % 8)/ 2)];
			}
		}
		printf("HIGH_nuevo: %i , WIDTH_nuevo: %i \n", high_nuevo, width_nuevo);
		//primero deberia liberar la memoria de i_matrix y luego pisarla
		//y modificar los valores de HIGH y WIDTH para el resto de la ejecucion
		//piso i_matrix con la matriz que acabo de generar
		free(i_matrix);
		i_matrix = i_matrix_red;
		
	}
}
*/
