#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "functions_sse.h"

#include "huffman.h"
#include "list.h"
//~ #include <xmmintrin.h>

extern int add_asm(int** i_matrix, int width, int i, int j);
extern int sub_asm(int** i_matrix, int width, int i, int j);
extern void dct_c1_asm(int** i_matrix, int i, int j, int width, float** temp);
extern void dct_c2_asm(float** temp, int i, int j, int width, int** temp2);

//~ double x[8] = {125, 3, -1, 12, 13, 15, -125, -122};
//~ double xdct[8];
//~ double xidct[8];
const double pi_sse = 3.14159265359;
float temp[8][8];
float temp_aux[8][8];
int temp_aux2[8][8];
int temp2[8][8];
//~ double temp2[8][8];
//~ #define PI 3.14159265358979
//~ 
//~ void coseno()
//~ {
	//~ int c, b;
	//~ for(b=0;b<8;b++)
	//~ {
		//~ for(c=0;c<8;c++)
		//~ {
			//~ printf("c:	%i b:	%i, coseno:	%f		\n", c , b , cos((pi/8)*(c+0.5)*b));
			//printf("c:	%i b:	%i, coseno:	%i		\n", c , b , cos((pi/8)*(c+0.5)*b));
		//~ }
		//~ printf("\n");
	//~ }
//~ }


void substract_128_asm( int ** i_matrix, int width, int high)
{
	int i, j;
	int error;

	for(i = 0; i < high ; i++)
	{
		for(j = 0; j < width ; j=j+4)
		{
			error = sub_asm(i_matrix[i], width, i, j);
			
			if (error != 0) printf("Error al restar 128\n");
		}
	}
}

void add_128_asm( int ** i_matrix, int width, int high)
{
	int i, j;
	int error;

	for(i = 0; i < high ; i++)
	{
		for(j = 0; j < width ; j=j+4)
		{
			error = add_asm(i_matrix[i], width, i, j);
			
			if (error != 0) printf("Error al restar 128\n");
		}
	}
}
void dct2_asm(int **imagen, int i, int j)
{
	int a,b,c;
	for(a=0;a<8;++a)
	{
		for(b=0;b<8;++b)
		{
			temp[a][b]=0.0;
			temp_aux[a][b]=0.0;
			temp2[a][b]=0;
			temp_aux2[a][b]=0;
		} 
	}

	for(a=0;a<8;++a)
	{
		dct_c1_asm(imagen[i+a], 0, j, 0, temp[a]);
	}
	
	//invierto la matriz temp para trabajar linealmente en en c2. Esta matriz esta en floats porque los convertimos a float en el c1 y los retornamos a int en c2 recien (justo antes de escribir en la imagen original para no perder presicion en la conversion del medio).
	
	int x,y;
	for(x=0;x<8;++x)
	{
		for(y=0;y<8;++y)
		{
			temp_aux[x][y] = temp[y][x];
		}
	}
	
	for(b=0;b<8;++b)
	{
		dct_c2_asm(temp_aux[b], i, j, 480, temp2[b]);
	}
	
	//vuelvo a invertir la matriz para que quede en el orden correcto
	for(a=0;a<8;++a)for(b=0;b<8;++b)imagen[i+a][j+b]=temp2[b][a];
}

void idct2_asm(int** imagen, int i, int j)
{
	int a,b,c;
	for(a=0;a<8;++a)
	{
		for(b=0;b<8;++b)
		{
			temp[a][b]=0.0;
			temp_aux[a][b]=0.0;
			temp2[a][b]=0;
			temp_aux2[a][b]=0;
		} 
	}

	//invierto la matriz temp para trabajar linealmente en en c2. Esta matriz esta en floats porque los convertimos a float en el c1 y los retornamos a int en c2 recien (justo antes de escribir en la imagen original para no perder presicion en la conversion del medio).
	for(a=0;a<8;++a)for(b=0;b<8;++b)temp_aux2[b][a]=imagen[i+a][j+b];	
		
	for(b=0;b<8;++b)
	{
		dct_c1_asm(temp_aux2[b], 0, 0, 480, temp[b]);
	}
	
	//vuelvo a invertir la matriz para que quede en el orden correcto
	int x,y;
	for(x=0;x<8;++x)
	{
		for(y=0;y<8;++y)
		{
			temp_aux[x][y] = temp[y][x];
		}
	}

	for(a=0;a<8;++a)
	{
		dct_c2_asm(temp_aux[a], 0, 0, 0, temp2[a]);
	}

	
	for(a=0;a<8;++a)for(b=0;b<8;++b)imagen[i+a][j+b]=temp2[a][b];
}

void divide_by_blocks_and_dct_asm(int ** i_matrix, int width, int high)
{
	int row_m ;
	int col_m ;
	int row_b ;
	int col_b ;
	
	int cant_blocks_w = width / 8;
	int cant_blocks_h = high / 8;
	
	
	for(row_m = 0; row_m < cant_blocks_h; row_m++)
	{
		for(col_m = 0; col_m < cant_blocks_w; col_m++)
		{
			row_b = row_m * 8;
			col_b = col_m * 8;
			dct2_asm(i_matrix, row_b, col_b );
		}
	}
	
}


void divide_by_blocks_and_idct_asm(int ** i_matrix, int width, int high)
{
	int row_m ;
	int col_m ;
	int row_b ;
	int col_b ;
	
	int cant_blocks_w = width / 8;
	int cant_blocks_h = high / 8;
		
	for(row_m = 0; row_m < cant_blocks_h; row_m++)
	{
		for(col_m = 0; col_m < cant_blocks_w; col_m++)
		{
			row_b = row_m * 8;
			col_b = col_m * 8;
			idct2(i_matrix, row_b, col_b );
		}
	}
	
}

void jpeg_asm(int ** i_matrix, int width, int high, int thresh)
{
	substract_128_asm(i_matrix, width, high);
	
	divide_by_blocks_and_dct_asm(i_matrix, width, high);
		
	divide_by_blocks_and_quant(i_matrix, width, high);
	
	//~ threshold (i_matrix, width, high, thresh);
}

void jpeg_dec_asm(int ** i_matrix, int width, int high)
{
	divide_by_blocks_and_m_quant(i_matrix, width, high);
	
	divide_by_blocks_and_idct_asm(i_matrix, width, high);

	add_128_asm(i_matrix, width, high);
	
}


