#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "huffman.h"
#include "list.h"

#define TAM_STR_A sizeof(nodo_arbol_t)
#define TAM_STR_L_A sizeof(nodo_lista_ab)
#define TAM_STR_L_C sizeof(nodo_lista_c)

oc2_main_header_t * read_main_header_oc2 (FILE * oc2_header)
{     
	/* TODO REVISARRR */
	//fseek(oc2_header, 0, SEEK_SET);
	oc2_main_header_t * oc2 = malloc(sizeof(oc2_main_header_t));
	
	fread(&oc2->offset_first_frame_header, sizeof(unsigned int), 1, oc2_header);
	fread(&oc2->cant_frames, sizeof(int), 1, oc2_header);
	fread(&oc2->fourcc, sizeof(int), 1, oc2_header);
	fread(&oc2->fps, sizeof(double), 1, oc2_header);
	fread(&oc2->width, sizeof(int), 1, oc2_header);
	fread(&oc2->height, sizeof(int), 1, oc2_header);
	
	return oc2;
}


nodo_arbol_t * crear_arbol_default ()
{
	nodo_arbol_t * nodo_nuevo;
	nodo_nuevo = malloc(TAM_STR_A);
	if (nodo_nuevo == NULL)
	{
		printf("no hay memoria \n");
	}
	nodo_nuevo->valido = INVALIDO;
	nodo_nuevo->apariciones = 0;
	nodo_nuevo->padre = NULL;
	nodo_nuevo->der = NULL;
	nodo_nuevo->izq = NULL;

	return nodo_nuevo;	
}

nodo_arbol_t * crear_arbol (char simbolo, unsigned int apariciones, unsigned int valido,
	void* padre, void* izquierda, void* derecha)
{
	nodo_arbol_t * nodo_nuevo;
	nodo_nuevo = malloc(TAM_STR_A);
	if (nodo_nuevo == NULL)
	{
		printf("no hay memoria \n");
	}
	nodo_nuevo->simbolo = simbolo;
	nodo_nuevo->valido = valido;
	nodo_nuevo->apariciones = apariciones;
	nodo_nuevo->padre = padre;
	nodo_nuevo->der = derecha;
	nodo_nuevo->izq = izquierda;

	return nodo_nuevo;
}

int eliminar_arbol (nodo_arbol_t * raiz)
{
	nodo_arbol_t * hijo_derecha;
	nodo_arbol_t * hijo_izquierda;
	int cant_hojas_elim = 0;
	
	if (raiz != NULL)
	{
		//~ printf("raiz no vacia\n");
		//~ printf("simbolo: %i\n", raiz->simbolo);
		hijo_derecha = raiz->der;
		hijo_izquierda = raiz->izq;
		if (raiz->valido == 1) cant_hojas_elim++;
		free(raiz);
		
		cant_hojas_elim = cant_hojas_elim + eliminar_arbol(hijo_derecha);
		cant_hojas_elim = cant_hojas_elim + eliminar_arbol(hijo_izquierda);
		//~ printf("cant hojas elim: %i\n", cant_hojas_elim);
		
	}
	
	return cant_hojas_elim;
}

void comprimir (int **i_matrix, int w, int h, int tam_header_bmp, FILE *  image_in,FILE * image_out)
{
	//printf("Comprimiendo.... \n");
	int fila;
	int col;

	nodo_lista_ab * lista_ab;
	//printf("generando tabla apariciones \n");
	lista_ab = generar_tabla_apariciones(i_matrix, w, h);
	//mostrar_lista_ab(lista_ab);

	//printf("generando tabla de codigos \n");
	nodo_lista_c * lista_c;
	lista_c = generar_lista_codigos(lista_ab);
	//~ mostrarListaAux(tabla_codigos);

	nodo_arbol_t * arbol;
	//printf("generando arbol huffman \n");
	arbol = generar_arbol_huffman(lista_ab);
	if (arbol == NULL)
	{
		printf("	ERROR\n"); //hubo un problema en generar arbol
	}
	//~ mostrarListaAux(tabla_codigos);
	//~ printf("mostrando arbol \n");
	//~ mostrarArbolAux(arbol, 0);
	
	//Eliminar lista_ab
	//printf ("Eliminando lista de nodos ab (apariciones)\n");
	int error = eliminar_lista_ab (lista_ab);
	if (error) printf ("	ERROR");
		
	int * long_codificado;
	long_codificado = malloc(sizeof(int));
	*long_codificado = 0;
	generar_codigos(lista_c, long_codificado);
	//printf(" long_codificado = %i \n", *long_codificado);
	//~ mostrar_codigos(lista_c);
	
	//Eliminar arbol huffman
	//printf ("Eliminando arbol de Huffman\n");
	int cant_nodos_elim = eliminar_arbol (arbol);
	//printf ("arbol de Huffman eliminadoooo\n");
	//~ printf("Eliminada %i hojas del arbol\n", cant_hojas_elim);
	
	unsigned int * buffer;
	buffer = comprimir_buffer(i_matrix, w, h, lista_c, *long_codificado);
	int p;
	int m;
	m = (*long_codificado + (32-*long_codificado % 32))/32;
	//printf("longitud de codificacion mod 32 %i \n", *long_codificado % 32);
	//printf("longitud de codificacion redondeado a b %i \n", *long_codificado + (32-*long_codificado % 32));
	//printf("longitud de codificacion  %i ints\n", m);
	//printf("longitud de codificacion %i b\n", *long_codificado);
	//~ for(p = 0; p < m; p++)
	//~ {
		//~ printf("%X ", buffer[p]);
	//~ }
	
	write_header(*long_codificado, tam_header_bmp, lista_c, image_in, image_out);
	
	int cant_codigos = long_lista_codigos(lista_c);
	int indice = tam_header_bmp + TAM_HEADER_OC2 + cant_codigos * 12;
	//printf ("Indice donde se comienza a escribir el buffer con la imagen: %i\n", indice);
	write_buffer(buffer, m, image_out, indice);
	//printf ("Eliminar buffer\n");
	free(buffer);
	
	//printf("Eliminar lista de codigos\n");
	error = eliminar_lista (lista_c);
	if (error) printf ("	ERROR");
	
	
	//~ print_matrix(i_matrix, w, h);
		//~ }
	//~ }
	//printf("Fin Comprimir...\n");
}

nodo_lista_ab * generar_tabla_apariciones(int ** i_matrix, int width, int high)
{
	//~ printf("\nGenerando lista de apariciones...\n");
	int i, j;
	nodo_lista_ab * lista = NULL;
	nodo_lista_ab * nodo_actual = lista;
	nodo_lista_ab * nodo_anterior = NULL;
	int * posicion; //es -1 si no esta
	posicion = malloc (sizeof(int));
	
	nodo_arbol_t * nodo_ab;
	//~ //limpio la tabla
	//~ for(i = 0; i < 500; i++)
	//~ {
		//~ tabla[i] = 0;
	//~ }
	
	for(i = 0; i < high; i++)
	{
		for(j = 0; j < width ; j++)
		{
			//~ printf("Simbolo leido: %i\n", i_matrix[i][j]);
			//~ printf("i: %i, j:%i \n", i, j);
			nodo_anterior = buscar_simbolo_ab(lista, i_matrix[i][j], posicion);
			//~ printf("POSICION: %i\n", *posicion);
			
			if( *posicion >= 0)
			{
				if (*posicion == 0) //el nodo actual es el primero, y la lista no esta vacia
				{
					//~ printf("Hay que modificar el primero\n");
					nodo_actual = lista;
					lista = lista->sig;
				}
				else
				{
					nodo_actual = nodo_anterior->sig;
					nodo_anterior->sig = nodo_actual->sig; //saco el nodo actual de la lista
				}

				nodo_ab = nodo_actual->nodo_arbol;
				nodo_ab->apariciones = nodo_ab->apariciones + 1; //agrego 1 a apariciones
					
				free(nodo_actual);
				lista = insertar_ordenado_ab(lista, nodo_ab);
				
			}
			else //el nodo correspondiente al simbolo no esta
			{
				//~ printf("	Primera aparicion\n");
				nodo_arbol_t * nuevo_nodo_ab = crear_arbol (i_matrix[i][j], 1, VALIDO, NULL, NULL,NULL);
				lista = insertar_ordenado_ab(lista, nuevo_nodo_ab);
			}
		
			//~ printf("fila: %i, col: %i, tab[%i]: %i \n", i, j, (int)i_matrix[i][j], tabla[i_matrix[i][j]]);
			//~ tabla[i_matrix[i][j]] = tabla[i_matrix[i][j]] + 1;
			
		}
	}
	//~ printf("Se genero la lista de apariciones\n");
	//~ mostrar_lista_ab(lista);
	return lista;
}

nodo_lista_c * generar_lista_codigos(nodo_lista_ab * lista_ab) 
{
	//~ printf("\nGenerar lista codigos...\n");
	nodo_lista_ab * ab_aux;
	ab_aux = lista_ab;
	nodo_lista_c * lista_c = NULL;
	nodo_lista_c * lista_aux;
	nodo_arbol_t * nodo_ab;
	
	while (ab_aux != NULL)
	{ 
		nodo_ab = ab_aux->nodo_arbol;
		//~ printf("Nodo arbol actual: %i(%i)", nodo_ab->simbolo, nodo_ab->apariciones);
		if (lista_c == NULL)
		{
			lista_c = crear_nodo_lista(nodo_ab, nodo_ab->simbolo, NULL);
			lista_aux = lista_c;
		}
		else
		{
			lista_aux->sig = crear_nodo_lista(nodo_ab, nodo_ab->simbolo, NULL);
			lista_aux = lista_aux->sig;
		}
		ab_aux = ab_aux->sig;
	}
	//~ printf("Se genero la lista de codigos: ");
	//~ mostrar_codigos(lista_c);
	//~ printf("\n");
	return lista_c;
}	
	
nodo_arbol_t * generar_arbol_huffman(nodo_lista_ab * lista)
{
	unsigned int sum_apar;
	nodo_lista_ab * nodo_aux;
	nodo_lista_ab * nodo_aux_2;
	nodo_aux = lista->sig;
	nodo_aux_2 = lista;

	while(lista->sig != NULL)
	{
		sum_apar = lista->nodo_arbol->apariciones + nodo_aux->nodo_arbol->apariciones;
		nodo_arbol_t * nodo_nuevo = crear_arbol(55,sum_apar,INVALIDO,NULL,nodo_aux->nodo_arbol,lista->nodo_arbol);
		
		lista->nodo_arbol->padre = nodo_nuevo;
		nodo_aux->nodo_arbol->padre = nodo_nuevo;
		//~ mostrarArbolAux(nodo_nuevo, 0);
		
		lista = nodo_aux->sig;
		
		free(nodo_aux);
		free(nodo_aux_2);
		//~ mostrarListaAux(lista);
		lista = insertar_ordenado_ab(lista, nodo_nuevo);
		//~ mostrarListaAux(lista);
		nodo_aux = lista->sig;
		nodo_aux_2 = lista;
	}
	return lista->nodo_arbol;
}

int generar_codigos(nodo_lista_c * lista, int * longitud_codificado)
{
	int i;
	int aux = 0;
	*longitud_codificado = 0;
	nodo_lista_c * nodo_aux = lista;
	
	while (nodo_aux != NULL)
	{
		aux = generar_codigo_aux(nodo_aux, longitud_codificado);
		if (aux == 1) break; 
		nodo_aux = nodo_aux->sig;
	}
	//mostrar_codigos(lista);
	return aux;
	
}

int generar_codigo_aux(nodo_lista_c * nodo, int * longitud_codificado)
{
	nodo_arbol_t * nodo_aux_ab;
	nodo_aux_ab = nodo->nodo_arbol;
	//~ printf("Simbolo: %i\n",nodo_aux_ab->simbolo);
	double cod_aux;
	cod_aux = 0;
	int nivel; //longitud de codigo = nivel +1
	nivel = 0;
	//derecha 0, izquierda 1(para el codigo)
	nodo_arbol_t * nodo_actual;
	
	while(nodo_aux_ab->padre != NULL)
	{
		//~ printf("padre no NULL (%i)\n",nodo_aux_ab->simbolo);
		nodo_actual = nodo_aux_ab->padre;
		if(nodo_aux_ab == nodo_actual->izq)
		{
			//~ printf("es izquierdo\n");
			cod_aux = (int)cod_aux | (int)pow(2, nivel);
		}
		 //~ else printf("es derecho\n");
		nivel++;
		nodo_aux_ab = nodo_actual;
	}
	//~ printf("\ntermino el codigo\n");
	nodo->long_cod = nivel;
	//~ printf("longitud_codificado: %i \n", *longitud_codificado);
	*longitud_codificado = *longitud_codificado + nivel * nodo->nodo_arbol->apariciones;
	//~ printf("longitud_codificado: %i \n", *longitud_codificado);
	if(nivel < 32)
	{
		nodo->codigo = (unsigned int) cod_aux;
		return 0;
	} else {
		printf ("Error al generar el codigo\n");
		return 1;
	}
	
}

oc2_header_t * leer_info_oc2 (FILE * compress_image)
{
	//~ fseek(compress_image, 0, SEEK_SET);
	oc2_header_t * oc2 = malloc(sizeof(oc2_header_t));
	fread(&oc2->offset_header, sizeof(unsigned int), 1, compress_image);
	fread(&oc2->tam_header, sizeof(unsigned int), 1, compress_image);
	fread(&oc2->offset_tabla, sizeof(unsigned int), 1, compress_image);
	fread(&oc2->long_codificacion, sizeof(unsigned int), 1, compress_image);
	fread(&oc2->cant_codigos, sizeof(unsigned int), 1, compress_image);
	fread(&oc2->offset_codificacion, sizeof(unsigned int), 1, compress_image);
	
	return oc2;
}

void mostrar_oc2 (oc2_header_t * oc2)
{
	printf("INFO OC2: \n");
	printf("	offset_header %i 0x%08X\n", oc2->offset_header, oc2->offset_header);
	printf("	tam_header %i 0x%08X\n", oc2->tam_header, oc2->tam_header);
	printf("	offset_tabla %i 0x%08X\n", oc2->offset_tabla, oc2->offset_tabla);
	printf("	long_codificacion %i 0x%08X\n", oc2->long_codificacion, oc2->long_codificacion);
	printf("	cant_codigos %i 0x%08X\n", oc2->cant_codigos, oc2->cant_codigos);
	printf("	offset_codificacion %i 0x%08X\n", oc2->offset_codificacion, oc2->offset_codificacion);
}

nodo_lista_c * leer_codigos (FILE * compress_image, unsigned int cant_codigos, unsigned int offset_tabla)
{
	
	//printf("Lista de codigos rearmados\n");
	//~ printf("Offset tabla %i\n", offset_tabla);
	//~ printf("Cantida de codigos a leer %i\n", cant_codigos);
	//~ printf("leer codigos posicion actual en headers_file: %i \n", ftell(compress_image) );
	//~ fseek (compress_image, offset_tabla, SEEK_CUR);
	//~ printf("leer codigos posicion actual en headers_file: %i \n", ftell(compress_image) );
	unsigned int i, aux;
	nodo_lista_c * lista_c = NULL;
	nodo_lista_c * nodo_anterior;
	nodo_lista_c * nodo_actual;
	for (i = 0; i < cant_codigos; ++i)
	{
		//~ printf("i = %i	", i);
		nodo_actual = crear_nodo_lista_default();
		fread(&aux, 4, 1, compress_image);
		//~ printf("aux: %i\n", (unsigned int) aux);
		nodo_actual->caracter = aux;
		fread(&aux, 4, 1, compress_image);
		nodo_actual->codigo = aux;
		fread(&aux, 4, 1, compress_image);
		nodo_actual->long_cod = aux;
		if (i == 0)
		{
			lista_c = nodo_actual;
			nodo_anterior = nodo_actual;
		}
		else
		{
			nodo_anterior->sig = nodo_actual;
			nodo_anterior = nodo_actual;
		}
		
		//~ printf("	Simbolo: %i, cod: %08X, long: %08X\n", nodo_actual->caracter, nodo_actual->codigo, nodo_actual->long_cod);
	}
	//printf("long lista codigos: %i \n",long_lista_codigos(lista_c));
	return lista_c;
}

nodo_arbol_t * generar_arbol_descomprecion (nodo_lista_c * tabla_cod, int cant_codigos)
 {
	 //printf("generando arbol descompresion ...\n");
	//genero al padre de todo el arbol
	nodo_arbol_t * padre_supremo;
	padre_supremo = malloc(TAM_STR_A);
	padre_supremo->simbolo = 66;
    padre_supremo->valido = 0;
    padre_supremo->padre = NULL;
	//al comenzar los hijos son NULL
    padre_supremo->izq = NULL;
    padre_supremo->der = NULL;
    
    //~ mostrarArbolAux(padre_supremo, 0);
    
    int long_cod_actual;
    int codigo_actual;
    int i;
    nodo_arbol_t * posicion_actual = padre_supremo;
   
    //voy a iterar sobre el array para ir generando las ramitas 
    nodo_lista_c * tabla_aux = tabla_cod;
	//~ printf("hola ptr: %i apunto a: , simb: %i \n", tabla_aux, tabla_aux->caracter);
	nodo_arbol_t * nodo_actual;
    while(tabla_aux != NULL)
    {
		//~ printf("ptr: %i codigo: %i, simb: %i \n", tabla_aux, tabla_aux->codigo, tabla_aux->caracter);
		codigo_actual = tabla_aux->codigo;
		//~ printf("codigo actual: %i", codigo_actual);
		long_cod_actual = tabla_aux->long_cod;
		
		for(long_cod_actual; long_cod_actual != 0; long_cod_actual--)
		{
			//~ printf("long actual: %i \n", long_cod_actual);
			int rama = (codigo_actual & (int)pow(2, long_cod_actual-1)); 
			
			if(rama == 0) //rama derecha
			{
				if(posicion_actual->der != NULL) //ya existe el hijo derecho
				{	
					if(long_cod_actual - 1 == 0)
					{
						printf("ERROR \n");
					}else{
						posicion_actual = posicion_actual->der;
					}	
				}else{
					nodo_actual = malloc(TAM_STR_A);
					nodo_actual->padre = posicion_actual;
					//al comenzar los hijos son NULL
					nodo_actual->izq = NULL;
					nodo_actual->der = NULL;
					if(long_cod_actual - 1 == 0)
					{
						//~ printf("llegue a hoja\n");
						nodo_actual->simbolo = tabla_aux->caracter;
						nodo_actual->valido = 1;
						posicion_actual->der = nodo_actual;
						posicion_actual = padre_supremo; //vuelvo a la raiz para iterar en otro caracter
					}else{
						nodo_actual->simbolo = 55;
						nodo_actual->valido = 0;
						posicion_actual->der = nodo_actual;
						posicion_actual = nodo_actual;
					}
				}
				
			}else{
				if(posicion_actual->izq != NULL) //ya existe el hijo izquierdo
				{	
					if(long_cod_actual - 1 == 0)
					{
						printf("ERROR \n");
					}else{
						posicion_actual = posicion_actual->izq;
					}	
				}else{
					nodo_actual = malloc(TAM_STR_A);
					nodo_actual->padre = posicion_actual;
					//al comenzar los hijos son NULL
					nodo_actual->izq = NULL;
					nodo_actual->der = NULL;
					if(long_cod_actual - 1 == 0)
					{
						//~ printf("llegue a hoja\n");
						nodo_actual->simbolo = tabla_aux->caracter;
						nodo_actual->valido = 1;
						posicion_actual->izq = nodo_actual;
						posicion_actual = padre_supremo; //vuelvo a la raiz para iterar en otro caracter
					}else{
						nodo_actual->simbolo = 55;
						nodo_actual->valido = 0;
						posicion_actual->izq = nodo_actual;
						posicion_actual = nodo_actual;
					}
				}
				
				
			}
		
		}
		tabla_aux = tabla_aux->sig;
	}
	return padre_supremo;    
 }
 
unsigned int * comprimir_buffer (int ** i_matrix, int width, int high, nodo_lista_c * lista, int long_codificado)
{
	int i, j, simb, cant_bits, long_cod_actual;
	unsigned int to_write, cod_aux, cod_actual;
	
	unsigned int * buffer;
	unsigned int * buffer_aux;
	nodo_lista_c * nodo_anterior;
	//~ printf ("voy a pedir memoria para el buffers %i long-cod %i\n", buffer, long_codificado);
	buffer = malloc(2*(long_codificado + (32-long_codificado % 32))/8); // necesito pedir memoria para redondear a 32 b
	//~ printf ("pedi memoria para el buffers %i \n", buffer);
	if (buffer == NULL) printf("No hay memoria.\n");
	buffer_aux = buffer;
	
	to_write = 0;
	cod_aux = 0;
	cod_actual = 0;
	cant_bits = 0;
	
	for (i = 0; i < high; ++i){
		for(j = 0; j < width; ++j){
			
			simb = i_matrix[i][j];
			//~ printf("simbolo a comprimir %i \n", simb);
			long_cod_actual = buscar_simbolo(lista, simb, nodo_anterior)->long_cod;
			//~ printf("long cod actual = %i \n", long_cod_actual);
			cod_actual = buscar_simbolo(lista, simb, nodo_anterior)->codigo;
			//~ printf("cod actual = %i\n", cod_actual);
			cod_aux = cod_actual;
			cant_bits = cant_bits + long_cod_actual;
			if (cant_bits > 32) cod_aux = cod_aux >> abs(32-cant_bits);
			else cod_aux = cod_aux << 32-cant_bits;
			//~ printf("cod_aux = int %i hex %X", cod_aux, cod_aux);
			to_write = to_write | cod_aux;
			//~ printf("  to_write: %i, %X \n", to_write, to_write);
			//~ printf("  cant bits: %i \n", cant_bits);
			if (cant_bits > 32)
			{
				//~ printf("entre al primer if\n");
				*buffer_aux = to_write;
				buffer_aux = buffer_aux ++;
				to_write = 0;
				cod_aux = cod_actual;
				cod_aux = cod_aux << 32 - (cant_bits - 32);
				//~ printf("ya shift cod_aux = int %i hex %X\n", cod_aux, cod_aux);
				to_write = cod_aux;
				cant_bits = (cant_bits - 32);
			}else{
			
				if (cant_bits == 32)
				{
					//~ printf("entre al 2do if\n");
					*buffer_aux = to_write;
					buffer_aux = buffer_aux ++;
					to_write = 0;
					cant_bits = 0;
				}else{
				
				//~ if (long_cod_actual + cant_bits < 32)
				//~ {
					//~ printf("entre al 3er if\n");
					//~ cant_bits = cant_bits + long_cod_actual;
				}
			}
		}
	}
	
	if (cant_bits > 0){
		*buffer_aux = to_write;
	}	
	
	return buffer;
}
 
void descomprimir_buffer(int long_codificacion, unsigned int * codif, int ** i_matrix, int width, int high, nodo_arbol_t * ptr_arbol_huff)
{
	//printf("descomprimir_buffer\n");
	//~ printf("long_codificacion %i\n", long_codificacion);
	int m,p;
	//~ m = (long_codificacion + (32-long_codificacion % 32))/8;
			
	//~ for(p = 0; p < m; p++)
		//~ {
			//~ printf("%X ", codif[p]);
		//~ }
	//~ printf("\n");
		
	int i;
	unsigned int aux;
	int bit;
	bit = 31;
	int fila;
	int col;
	fila = 0;
	col = 0;
	nodo_arbol_t * ptr_aux;
	ptr_aux = ptr_arbol_huff;
	
	//~ mostrarArbolAux(ptr_arbol_huff,0);
	
	for(i = 0; i < long_codificacion; i++)
	{
		if(fila == high && col == width) break;
		//~ printf("i: %i\n", i);
		//~ printf("simbolo: %i \n", ptr_aux->simbolo);
		aux = codif[i/32]; //quiero poner en aux el codigo
		//~ printf("aux: %X \n", aux);
		aux = (unsigned int)aux & (unsigned int)(pow(2, bit));
		//~ printf("aux: %X \n", aux);
		if (aux != 0)
		{
			ptr_aux = ptr_aux->izq;
		}else{
			ptr_aux = ptr_aux->der;
		}
		bit--;
		//~ printf("simbolo: %i \n", ptr_aux->simbolo);
		if(ptr_aux->valido)
		{
			//llegue a una hoja
			//~ printf("valido: %i \n", ptr_aux->valido);
			//~ printf("simbolo a descomprimir %i \n", ptr_aux->simbolo);
			//~ printf("fila: %i, col:%i \n", fila, col);
			i_matrix[fila][col] = ptr_aux->simbolo;
			ptr_aux = ptr_arbol_huff;
			col++;
			if(col == width)
			{
				fila++;
				if(fila != high )
				{
					col = 0;
				}
			}
		}
		if(bit < 0)
		{
			bit = 31;
			//avanzar el puntero de la codificacion
			//~ codif = codif+32;
		}
			
	}
}
 
void alinear ( char ch, int n ) 
{
	int i;
    for ( i = 0; i < n; i++ ) 
    {
		putchar ( ch );
    }
}

void mostrarArbolAux ( nodo_arbol_t *raiz, int nivel ) 
{
        int i;
        //~ printf("-------------------------------------MUESTRO ALGO\n");
        if ( raiz == NULL ) 
        {
                alinear ( '\t', nivel );
                puts("~");
                //printf("termine una rama\n");
        } else {
				//~ printf("nivel: %i\n", nivel);

                mostrarArbolAux ( raiz->izq, nivel + 1 );

                alinear ( '\t', nivel );
                //~ printf ( "%i(%i)\n", raiz->simbolo, raiz->apariciones );
                mostrarArbolAux ( raiz->der, nivel + 1 );
        }
        //~ printf("-------------------------------------FIN \n");
}

void mostrar_tabla(int * t)
{
	printf("\n[ ");
	int i;
	for(i = 0; i < 500; i++)
	{
		printf("%i ", t[i]);
	}
	printf("] \n");
} 
 
void write_info_oc2 (FILE * image_out, oc2_header_t * oc2)
{
	//printf ("Escribiendo header oc2\n");

	//~ fseek(image_out, 0, SEEK_CUR);
	fwrite(&oc2->offset_header, sizeof(int), 1, image_out);
	fwrite(&oc2->tam_header, sizeof(int), 1, image_out);
	fwrite(&oc2->offset_tabla, sizeof(int), 1, image_out);
	fwrite(&oc2->long_codificacion, sizeof(int), 1, image_out);
	fwrite(&oc2->cant_codigos, sizeof(int), 1, image_out);
	fwrite(&oc2->offset_codificacion, sizeof(int), 1, image_out);
	
}

void write_header(int long_codificacion, int tam_header_bmp, nodo_lista_c * tabla_codif, FILE* image_in, FILE* image_out)
{
	int aux;
	unsigned int uaux;
	long int posicion;
	 
	oc2_header_t oc2;
	oc2.offset_header = sizeof(oc2_header_t);
	oc2.tam_header = tam_header_bmp;
	oc2.cant_codigos = long_lista_codigos(tabla_codif);
	oc2.offset_tabla = oc2.tam_header + oc2.offset_header;
	oc2.long_codificacion = long_codificacion;
	oc2.offset_codificacion = oc2.offset_tabla + oc2.cant_codigos * 3 * sizeof(int);
	
	mostrar_oc2 (&oc2);
	write_info_oc2(image_out, &oc2);
	
	//printf("escribiendo el header...");
	fseek(image_in, 0, SEEK_SET);
	
	int i;
	int aux_header;
	posicion = ftell(image_out);
	//~ printf("posicion: %i	%08X\n", posicion, posicion);
	for(i = 0; i < tam_header_bmp; i++)
	{
		aux_header = fgetc(image_in);
		fputc(aux_header, image_out);
	}
	
	posicion = ftell(image_out);
	//~ printf("posicion: %i	%08X\n", posicion, posicion);

    nodo_lista_c * nodo_aux_l;
    nodo_aux_l = tabla_codif;

	while(nodo_aux_l != NULL)
	{
		
		aux = 0;
		//~ fwrite(&aux, 4, 1, image_out);
		aux = nodo_aux_l->caracter;
		posicion = ftell(image_out);
		//~ printf("simbolo actual: %i	%X \n", aux, aux);
		//~ printf("posicion: %i	%08X\n", posicion, posicion);
		//~ fputc(aux, image_out);
		fwrite(&aux, 4, 1, image_out);
		
		
		//~ fprintf(image_out, "%i", aux);
		//~ printf("simbolo actual: %i	%X \n", aux, aux);
		uaux = nodo_aux_l->codigo;
		//~ fputc(aux_c, image_out);
		//~ printf("uaux: %08X \n", uaux);
		//~ printf("aux: %08X uaux: %08X \n", &aux, &uaux);
		//~ printf("tam int: %i, tam_uint: %i\n", sizeof(int), sizeof(unsigned int));
		fwrite(&uaux, sizeof(unsigned int), 1, image_out);
		uaux = nodo_aux_l->long_cod;
		//~ printf("uaux: %08X \n", uaux);
		//~ fputc(aux_c, image_out);
		fwrite(&uaux, sizeof(unsigned int), 1, image_out);
		nodo_aux_l = nodo_aux_l->sig;
	}
	//~ fclose(image_out_2);
	posicion = ftell(image_out);
	//~ printf("posicion: %i	%08X\n", posicion, posicion);
	
}

void write_header_video(int long_codificacion, nodo_lista_c * tabla_codif, FILE* image_out)
{
	int aux;
	unsigned int uaux;
	 
	oc2_header_t oc2;
	oc2.offset_header = sizeof(oc2_header_t);
	oc2.tam_header = 0;
	oc2.cant_codigos = long_lista_codigos(tabla_codif);
	//~ printf("cant_codigos compresion: %i \n", oc2.cant_codigos);
	oc2.offset_tabla = oc2.tam_header + oc2.offset_header;
	oc2.long_codificacion = long_codificacion;
	oc2.offset_codificacion = oc2.offset_tabla + oc2.cant_codigos * 3 * sizeof(int);
	
	//~ mostrar_oc2 (&oc2);
	write_info_oc2(image_out, &oc2);
	
    nodo_lista_c * nodo_aux_l;
    nodo_aux_l = tabla_codif;

	while(nodo_aux_l != NULL)
	{
		aux = 0;
		aux = nodo_aux_l->caracter;
		fwrite(&aux, 4, 1, image_out);
		
		uaux = nodo_aux_l->codigo;
		fwrite(&uaux, sizeof(unsigned int), 1, image_out);
		uaux = nodo_aux_l->long_cod;
		fwrite(&uaux, sizeof(unsigned int), 1, image_out);
		nodo_aux_l = nodo_aux_l->sig;
	}
}

void write_buffer(unsigned int * buffer, int m, FILE * image_out, int indice)
{
	fseek(image_out, indice, SEEK_SET);
	int i;
	unsigned int aux;
	for(i=0; i < m; i++)
	{
		aux = buffer[i];
		//~ fputc(aux, image_out);
		if(i < 4) printf("buffer: %X  ", buffer[i]);
		fwrite(&aux, sizeof(int), 1, image_out);
	}
	//printf("\n");
} 

 
void imprimir_archivo_codigos (nodo_lista_c * codigos)
{
	FILE * codigos_file = fopen("tabla_codigos_descompresion.tex", "wb+");
	int i;
	nodo_lista_c * cod_aux = codigos;
	while (cod_aux->sig != NULL)
	{
		fwrite(&cod_aux->caracter,sizeof(int),1,codigos_file);
		fwrite(&cod_aux->codigo,sizeof(unsigned int),1,codigos_file);
		fwrite(&cod_aux->long_cod,sizeof(unsigned int),1,codigos_file);
		cod_aux = cod_aux->sig;
	}
	fclose(codigos_file);
}
