#include <stdio.h>
#include <stdlib.h>
#include "functions.h"
#include "functions_sse.h"

//includes para opencv
#include <cv.h>
#include "highgui.h"

//para los tiempos
#include <sys/time.h>

#include <string.h>
//~ #define HIGH 512
//~ #define WIDTH 512
#define offset_size_file 2
#define offset_begin_image 10


int main(int argc, char** argv)
{
        // Guardar nombre del archivo para usarlo en la ayuda
    //~ char* nombre_programa = argv[0];
    //~ char* nombre_archivo = argv[1];
    
	//~ printf("argv 0 : %s  argv[1] %s \n", nombre_programa, nombre_archivo);
	struct timeval start,end;

    CvCapture* capture=0;
    IplImage* frame=0;
	FILE *tiempos;
	tiempos = fopen("output_para_graficos.txt", "wb+");
	
    capture = cvCaptureFromCAM(0); // read from webcam 
    //~ capture = cvCaptureFromAVI("videoprueba.AVI"); // read AVI video   
    
    cvNamedWindow( "w", 1);
    cvNamedWindow( "w_out", 1);
    
    
    for( ; ; )
    {
		cvWaitKey(30);
//		printf("ciclando\n");
        frame = cvQueryFrame( capture );
        
        if(!frame)
        {
            break;
        }
        
        IplImage *im_gray = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
		cvCvtColor(frame,im_gray,CV_BGR2GRAY);

		int high, width;
		high = im_gray->height;
		width = im_gray->width;

		gettimeofday(&start,NULL);
		double tiempo;
		
		int **i_matrix;
		int i;
		i_matrix = (int**) malloc (im_gray->height * sizeof (int*));    
		for (i = 0; i < im_gray->height; i++)
			i_matrix[i] = (int*) malloc (im_gray->width * sizeof (int)); 

		read_image_ipl (im_gray, i_matrix);

		int res;

		jpeg(i_matrix, width, high, -200);
		jpeg_dec(i_matrix, width, high);
		//~ 
		//~ jpeg_asm(i_matrix, width, high, -200);
		//~ jpeg_dec_asm(i_matrix, width, high);
		        //~ 
        gettimeofday(&end,NULL);
		tiempo = (1000000*(end.tv_sec-start.tv_sec)+(end.tv_usec-start.tv_usec))/1000000.0;
		fprintf(tiempos, "%.10lf \n", tiempo);
		printf("Tardo %.10lf segundos\n", tiempo);
        
        IplImage *im_out = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
        write_image_ipl (im_out, i_matrix);
        cvShowImage("w_out", im_out);
        cvShowImage("w", im_gray);
        for (i = 0; i < im_gray->height; i++)
			free(i_matrix[i]); 

        //~ break;
        
    }
     
    //cvWaitKey(0); // key press to close window
    cvDestroyWindow("w");
    cvReleaseImage(&frame);
    fclose(tiempos);
	return 0;
}
