#include <stdio.h>
#include <stdlib.h>
#include "functions.h"
#include "compression.h"

//includes para opencv
#include <cv.h>
#include "highgui.h"

#define offset_size_file 2
#define offset_begin_image 10
//~ #define corre_con_c 0
//~ #define corre_con_asm 1


int main(int argc, char** argv)
{
	char* nombre_programa = argv[0];
	char* case1a = "	%s 10 	thresh(opt)			--> Compresion desde webcam (ASM)\n";
	char* case2a = "	%s 20 	thresh(opt) 	archivo.AVI 	--> Compresión de video AVI (ASM)\n";
	char* case3a = "	%s 30 			archivo.AVI 	--> Descompresion de video AVI (ASM)\n";
	char* case4a = "	%s 40 	thresh(opt) 	archivo.AVI 	--> Compresion y descompresion de video AVI (ASM)\n";
	char* case5a = "	%s 50 	thresh(opt) 	archivo.bmp 	--> Compresion de bmp (ASM)\n";
	char* case6a = "	%s 60 			archivo.bmp 	--> Descompresion de bmp AVI (ASM)\n";
	char* case8a = "	%s 80 	thresh(opt) 	archivo.bmp 	--> Compresion y Descompresion de bmp (ASM)\n";
	char* case1c = "	%s 11 	thresh(opt)		 	--> Compresion desde webcam\n";
	char* case2c = "	%s 21 	thresh(opt) 	archivo.AVI 	--> Compresión de video\n";
	char* case3c = "	%s 31 			archivo.AVI 	--> Descompresion de video\n";
	char* case4c = "	%s 41 	thresh(opt) 	archivo.AVI 	--> Compresion y descompresion de video AVI\n";
	char* case5c = "	%s 51 	thresh(opt) 	archivo.bmp 	--> Compresion de bmp AVI\n";
	char* case6c = "	%s 61 			archivo.bmp 	--> Descompresion de bmp AVI\n";
	char* case8c = "	%s 81 	thresh(opt) 	archivo.bmp 	--> Compresion y Descompresion de bmp \n";
	char* case7 = "	%s 7 			archivo.AVI 	--> Video grayscale sin audio \n";
	
	if (argc < 2){
		printf("Pocos argumentos\nModo de uso:\n");
		printf(case1a, nombre_programa);
		printf(case1c, nombre_programa);
		printf(case2a, nombre_programa);
		printf(case2c, nombre_programa);
		printf(case3a, nombre_programa);
		printf(case3c, nombre_programa);
		printf(case4a, nombre_programa);
		printf(case4c, nombre_programa);
		printf(case5a, nombre_programa);
		printf(case5c, nombre_programa);
		printf(case6a, nombre_programa);
		printf(case6c, nombre_programa);
		printf(case7, nombre_programa);
		return 0;
	}
	
	int thresh = -100;
	
	switch(atoi(argv[1])){
		case 10:	// Compresion desde webcam
			if (argc > 2) thresh = atoi(argv[2]);
			jpeg_from_webcam (thresh, corre_con_asm);
			break;
		
		case 11:	// Compresion desde webcam
			if (argc > 2) thresh = atoi(argv[2]);
			jpeg_from_webcam (thresh, corre_con_c);
			break;
		
		case 20:	//Compresion desde AVI
			if (argc < 3){
				printf("Modo de uso:");
				printf(case2a, nombre_programa);
				return 0;
			}
			if (argc > 3) thresh = atoi(argv[3]);
			compress_AVI(argv[2], thresh, corre_con_asm);
			break;
		
		case 21:	//Compresion desde AVI
			if (argc < 3){
				printf("Modo de uso:");
				printf(case2c, nombre_programa);
				return 0;
			}
			if (argc > 3) thresh = atoi(argv[3]);
			compress_AVI(argv[2], thresh, corre_con_c);
			break;
		
		case 30:	// Descompresion de video desde archivo
			if (argc < 3){
				printf("Modo de uso:");
				printf(case3a, nombre_programa);
				return 0;
			}
			descompress_AVI(argv[2], corre_con_asm);
			break;
	
		case 31:	// Descompresion de video desde archivo
			if (argc < 3){
				printf("Modo de uso: %s 3 archivo.avi\n",nombre_programa);
				printf(case3c, nombre_programa);
				return 0;
			}
			descompress_AVI(argv[2], corre_con_c);
			break;
	
		case 40:	// Descompresion de video desde archivo
			if (argc < 3){
				printf("Modo de uso: \n",nombre_programa);
				printf(case4a, nombre_programa);
				return 0;
			}
			if (argc > 3) thresh = atoi(argv[3]);
			compress_and_descompress_AVI (argv[2], thresh, corre_con_asm);
			//~ compress_AVI(argv[2], thresh, corre_con_asm);
			//~ descompress_AVI(argv[2], corre_con_asm);
			break;

		case 41:	// Descompresion de video desde archivo
			if (argc < 3){
				printf("Modo de uso: \n",nombre_programa);
				printf(case4c, nombre_programa);
				return 0;
			}
			if (argc > 3) thresh = atoi(argv[3]);
			compress_and_descompress_AVI (argv[2], thresh, corre_con_c);
			//~ compress_AVI(argv[2], thresh, corre_con_c);
			//~ descompress_AVI(argv[2], corre_con_c);
			break;

		case 50:	//Compresion desde BMP
			if (argc < 3){
				printf("Modo de uso: \n");
				printf(case5a, nombre_programa);
				return 0;
			}
			if (argc > 3) thresh = atoi(argv[3]);
			compress_image(argv[2], thresh, corre_con_asm);
			break;

		case 51:	//Compresion desde BMP
			if (argc < 3){
				printf("Modo de uso: \n");
				printf(case5c, nombre_programa);
				return 0;
			}
			if (argc > 3) thresh = atoi(argv[2]);
			compress_image(argv[2], thresh, corre_con_c);
			break;

		case 60:	//Descompresion desde BMP
			if (argc < 3){
				printf("Modo de uso: ");
				printf(case6a, nombre_programa);
				return 0;
			}
			descompress_image(argv[2], corre_con_asm);
			break;

		case 61:	//Descompresion desde BMP
			if (argc < 3){
				printf("Modo de uso: ");
				printf(case6c, nombre_programa);
				return 0;
			}
			descompress_image(argv[2], corre_con_c);
			break;
		
		case 80:	//Psnr BMP
			if (argc < 3){
				printf("Modo de uso: ");
				printf(case6a, nombre_programa);
				return 0;
			}
			//~ compress_and_decompress_image(argv[2], thresh, corre_con_asm);
			compress_image(argv[2], thresh, corre_con_asm);
			descompress_image(argv[2], corre_con_asm);
			break;

		case 81:	//Psnr BMP
			if (argc < 3){
				printf("Modo de uso: ");
				printf(case6c, nombre_programa);
				return 0;
			}
			//~ compress_and_decompress_image(argv[2], thresh, corre_con_c);
			compress_image(argv[2], thresh, corre_con_c);
			descompress_image(argv[2], corre_con_c);
			break;

		case 7:	// Descompresion de video desde archivo
			if (argc < 3){
				printf("Modo de uso: \n",nombre_programa);
				printf(case7, nombre_programa);
				return 0;
			}
			crear_video_avi_sin_audio(argv[2]);
			break;
						
		default:
			printf("Modo de uso:\n");
			printf(case1a, nombre_programa);
			printf(case1c, nombre_programa);
			printf(case2a, nombre_programa);
			printf(case2c, nombre_programa);
			printf(case3a, nombre_programa);
			printf(case3c, nombre_programa);
			printf(case4a, nombre_programa);
			printf(case4c, nombre_programa);
			printf(case5a, nombre_programa);
			printf(case5c, nombre_programa);
			printf(case6a, nombre_programa);
			printf(case6c, nombre_programa);
			printf(case7, nombre_programa);
			break;
	}

	/* COMPRIMIENDO VIDEO */
    char* nombre_archivo = argv[1];
   	
	return 0;
}
